// services/viz/public/mojom/compositing/filter_operation.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_FILTER_OPERATION_MOJOM_BLINK_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_FILTER_OPERATION_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/viz/public/mojom/compositing/filter_operation.mojom-shared.h"
#include "services/viz/public/mojom/compositing/filter_operation.mojom-blink-forward.h"
#include "services/viz/public/mojom/compositing/paint_filter.mojom-blink.h"
#include "skia/public/mojom/blur_image_filter_tile_mode.mojom-blink.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "third_party/blink/public/platform/web_common.h"




namespace WTF {
struct viz_mojom_internal_FilterType_DataHashFn {
  static unsigned GetHash(const ::viz::mojom::FilterType& value) {
    using utype = std::underlying_type<::viz::mojom::FilterType>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::viz::mojom::FilterType& left, const ::viz::mojom::FilterType& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct HashTraits<::viz::mojom::FilterType>
    : public GenericHashTraits<::viz::mojom::FilterType> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::viz::mojom::FilterType& value) {
    return value == static_cast<::viz::mojom::FilterType>(-1000000);
  }
  static void ConstructDeletedValue(::viz::mojom::FilterType& slot, bool) {
    slot = static_cast<::viz::mojom::FilterType>(-1000001);
  }
  static bool IsDeletedValue(const ::viz::mojom::FilterType& value) {
    return value == static_cast<::viz::mojom::FilterType>(-1000001);
  }
};
}  // namespace WTF

// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace viz {
namespace mojom {
namespace blink {








class BLINK_PLATFORM_EXPORT FilterOperation {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<FilterOperation, T>::value>;
  using DataView = FilterOperationDataView;
  using Data_ = internal::FilterOperation_Data;

  template <typename... Args>
  static FilterOperationPtr New(Args&&... args) {
    return FilterOperationPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static FilterOperationPtr From(const U& u) {
    return mojo::TypeConverter<FilterOperationPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, FilterOperation>::Convert(*this);
  }


  FilterOperation();

  FilterOperation(
      FilterType type,
      float amount,
      float outer_threshold,
      const ::gfx::Point& drop_shadow_offset,
      uint32_t drop_shadow_color,
      ::viz::mojom::blink::PaintFilterPtr image_filter,
      base::Optional<WTF::Vector<float>> matrix,
      int32_t zoom_inset,
      ::SkBlurImageFilter::TileMode blur_tile_mode,
      base::Optional<WTF::Vector<::gfx::Rect>> shape);

  ~FilterOperation();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = FilterOperationPtr>
  FilterOperationPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        FilterOperation::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        FilterOperation::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::FilterOperation_UnserializedMessageContext<
            UserType, FilterOperation::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<FilterOperation::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return FilterOperation::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::FilterOperation_UnserializedMessageContext<
            UserType, FilterOperation::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<FilterOperation::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  FilterType type;
  
  float amount;
  
  float outer_threshold;
  
  ::gfx::Point drop_shadow_offset;
  
  uint32_t drop_shadow_color;
  
  ::viz::mojom::blink::PaintFilterPtr image_filter;
  
  base::Optional<WTF::Vector<float>> matrix;
  
  int32_t zoom_inset;
  
  ::SkBlurImageFilter::TileMode blur_tile_mode;
  
  base::Optional<WTF::Vector<::gfx::Rect>> shape;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
  DISALLOW_COPY_AND_ASSIGN(FilterOperation);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, FilterOperation::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
FilterOperationPtr FilterOperation::Clone() const {
  return New(
      mojo::Clone(type),
      mojo::Clone(amount),
      mojo::Clone(outer_threshold),
      mojo::Clone(drop_shadow_offset),
      mojo::Clone(drop_shadow_color),
      mojo::Clone(image_filter),
      mojo::Clone(matrix),
      mojo::Clone(zoom_inset),
      mojo::Clone(blur_tile_mode),
      mojo::Clone(shape)
  );
}

template <typename T, FilterOperation::EnableIfSame<T>*>
bool FilterOperation::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->type, other_struct.type))
    return false;
  if (!mojo::Equals(this->amount, other_struct.amount))
    return false;
  if (!mojo::Equals(this->outer_threshold, other_struct.outer_threshold))
    return false;
  if (!mojo::Equals(this->drop_shadow_offset, other_struct.drop_shadow_offset))
    return false;
  if (!mojo::Equals(this->drop_shadow_color, other_struct.drop_shadow_color))
    return false;
  if (!mojo::Equals(this->image_filter, other_struct.image_filter))
    return false;
  if (!mojo::Equals(this->matrix, other_struct.matrix))
    return false;
  if (!mojo::Equals(this->zoom_inset, other_struct.zoom_inset))
    return false;
  if (!mojo::Equals(this->blur_tile_mode, other_struct.blur_tile_mode))
    return false;
  if (!mojo::Equals(this->shape, other_struct.shape))
    return false;
  return true;
}

template <typename T, FilterOperation::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.type, rhs.type))
    return true;
  if (std::less<>{}(rhs.type, lhs.type))
    return false;
  if (std::less<>{}(lhs.amount, rhs.amount))
    return true;
  if (std::less<>{}(rhs.amount, lhs.amount))
    return false;
  if (std::less<>{}(lhs.outer_threshold, rhs.outer_threshold))
    return true;
  if (std::less<>{}(rhs.outer_threshold, lhs.outer_threshold))
    return false;
  if (std::less<>{}(lhs.drop_shadow_offset, rhs.drop_shadow_offset))
    return true;
  if (std::less<>{}(rhs.drop_shadow_offset, lhs.drop_shadow_offset))
    return false;
  if (std::less<>{}(lhs.drop_shadow_color, rhs.drop_shadow_color))
    return true;
  if (std::less<>{}(rhs.drop_shadow_color, lhs.drop_shadow_color))
    return false;
  if (std::less<>{}(lhs.image_filter, rhs.image_filter))
    return true;
  if (std::less<>{}(rhs.image_filter, lhs.image_filter))
    return false;
  if (std::less<>{}(lhs.matrix, rhs.matrix))
    return true;
  if (std::less<>{}(rhs.matrix, lhs.matrix))
    return false;
  if (std::less<>{}(lhs.zoom_inset, rhs.zoom_inset))
    return true;
  if (std::less<>{}(rhs.zoom_inset, lhs.zoom_inset))
    return false;
  if (std::less<>{}(lhs.blur_tile_mode, rhs.blur_tile_mode))
    return true;
  if (std::less<>{}(rhs.blur_tile_mode, lhs.blur_tile_mode))
    return false;
  if (std::less<>{}(lhs.shape, rhs.shape))
    return true;
  if (std::less<>{}(rhs.shape, lhs.shape))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace viz

namespace mojo {


template <>
struct BLINK_PLATFORM_EXPORT StructTraits<::viz::mojom::blink::FilterOperation::DataView,
                                         ::viz::mojom::blink::FilterOperationPtr> {
  static bool IsNull(const ::viz::mojom::blink::FilterOperationPtr& input) { return !input; }
  static void SetToNull(::viz::mojom::blink::FilterOperationPtr* output) { output->reset(); }

  static decltype(::viz::mojom::blink::FilterOperation::type) type(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->type;
  }

  static decltype(::viz::mojom::blink::FilterOperation::amount) amount(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->amount;
  }

  static decltype(::viz::mojom::blink::FilterOperation::outer_threshold) outer_threshold(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->outer_threshold;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::drop_shadow_offset)& drop_shadow_offset(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->drop_shadow_offset;
  }

  static decltype(::viz::mojom::blink::FilterOperation::drop_shadow_color) drop_shadow_color(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->drop_shadow_color;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::image_filter)& image_filter(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->image_filter;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::matrix)& matrix(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->matrix;
  }

  static decltype(::viz::mojom::blink::FilterOperation::zoom_inset) zoom_inset(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->zoom_inset;
  }

  static decltype(::viz::mojom::blink::FilterOperation::blur_tile_mode) blur_tile_mode(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->blur_tile_mode;
  }

  static const decltype(::viz::mojom::blink::FilterOperation::shape)& shape(
      const ::viz::mojom::blink::FilterOperationPtr& input) {
    return input->shape;
  }

  static bool Read(::viz::mojom::blink::FilterOperation::DataView input, ::viz::mojom::blink::FilterOperationPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_FILTER_OPERATION_MOJOM_BLINK_H_