// ui/accessibility/mojom/ax_assistant_structure.mojom-blink.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "ui/accessibility/mojom/ax_assistant_structure.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/common/task_annotator.h"
#include "base/trace_event/trace_conversion_helper.h"
#include "base/trace_event/traced_value.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "ui/accessibility/mojom/ax_assistant_structure.mojom-params-data.h"
#include "ui/accessibility/mojom/ax_assistant_structure.mojom-shared-message-ids.h"

#include "ui/accessibility/mojom/ax_assistant_structure.mojom-blink-import-headers.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"


#ifndef UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_BLINK_JUMBO_H_
#define UI_ACCESSIBILITY_MOJOM_AX_ASSISTANT_STRUCTURE_MOJOM_BLINK_JUMBO_H_
#endif
namespace ax {
namespace mojom {
namespace blink {
AssistantTree::AssistantTree()
    : nodes() {}

AssistantTree::AssistantTree(
    WTF::Vector<AssistantNodePtr> nodes_in)
    : nodes(std::move(nodes_in)) {}

AssistantTree::~AssistantTree() = default;

void AssistantTree::AsValueInto(base::trace_event::TracedValue* value) const {
  value->BeginArray("nodes");
  for (const auto& item0 : this->nodes) {
    if (item0.is_null()) {
      value->AppendString("nullptr");
    } else {
      value->BeginDictionary();
      item0->AsValueInto(value);
      value->EndDictionary();
    }
  }
  value->EndArray();
}

bool AssistantTree::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
AssistantNode::AssistantNode()
    : children_indices(),
      rect(),
      text(),
      text_size(),
      color(),
      bgcolor(),
      bold(),
      italic(),
      underline(),
      line_through(),
      selection(),
      class_name(),
      role() {}

AssistantNode::AssistantNode(
    WTF::Vector<int32_t> children_indices_in,
    const ::gfx::Rect& rect_in,
    const ::WTF::String& text_in,
    float text_size_in,
    uint32_t color_in,
    uint32_t bgcolor_in,
    bool bold_in,
    bool italic_in,
    bool underline_in,
    bool line_through_in,
    const base::Optional<::gfx::Range>& selection_in,
    const WTF::String& class_name_in,
    const WTF::String& role_in)
    : children_indices(std::move(children_indices_in)),
      rect(std::move(rect_in)),
      text(std::move(text_in)),
      text_size(std::move(text_size_in)),
      color(std::move(color_in)),
      bgcolor(std::move(bgcolor_in)),
      bold(std::move(bold_in)),
      italic(std::move(italic_in)),
      underline(std::move(underline_in)),
      line_through(std::move(line_through_in)),
      selection(std::move(selection_in)),
      class_name(std::move(class_name_in)),
      role(std::move(role_in)) {}

AssistantNode::~AssistantNode() = default;

void AssistantNode::AsValueInto(base::trace_event::TracedValue* value) const {
  value->BeginArray("children_indices");
  for (const auto& item0 : this->children_indices) {
    value->AppendInteger(item0);
  }
  value->EndArray();
  value->SetString("rect", base::trace_event::ValueToString(this->rect, "<value of type const ::gfx::Rect&>"));
  value->SetString("text", base::trace_event::ValueToString(this->text, "<value of type const ::WTF::String&>"));
  value->SetDouble("text_size", this->text_size);
  value->SetString("color", base::NumberToString(this->color));
  value->SetString("bgcolor", base::NumberToString(this->bgcolor));
  value->SetBoolean("bold", this->bold);
  value->SetBoolean("italic", this->italic);
  value->SetBoolean("underline", this->underline);
  value->SetBoolean("line_through", this->line_through);
  value->SetString("selection", base::trace_event::ValueToString(this->selection, "<value of type const base::Optional<::gfx::Range>&>"));
  value->SetString("class_name", this->class_name.Utf8());
  value->SetString("role", this->role.Utf8());
}

bool AssistantNode::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
AssistantExtra::AssistantExtra()
    : url(),
      bounds_pixel(),
      title() {}

AssistantExtra::AssistantExtra(
    const ::blink::KURL& url_in,
    const ::gfx::Rect& bounds_pixel_in,
    const ::WTF::String& title_in)
    : url(std::move(url_in)),
      bounds_pixel(std::move(bounds_pixel_in)),
      title(std::move(title_in)) {}

AssistantExtra::~AssistantExtra() = default;

void AssistantExtra::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("url", base::trace_event::ValueToString(this->url, "<value of type const ::blink::KURL&>"));
  value->SetString("bounds_pixel", base::trace_event::ValueToString(this->bounds_pixel, "<value of type const ::gfx::Rect&>"));
  value->SetString("title", base::trace_event::ValueToString(this->title, "<value of type const ::WTF::String&>"));
}

bool AssistantExtra::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
AssistantStructure::AssistantStructure()
    : assistant_tree(),
      assistant_extra() {}

AssistantStructure::AssistantStructure(
    AssistantTreePtr assistant_tree_in,
    AssistantExtraPtr assistant_extra_in)
    : assistant_tree(std::move(assistant_tree_in)),
      assistant_extra(std::move(assistant_extra_in)) {}

AssistantStructure::~AssistantStructure() = default;

void AssistantStructure::AsValueInto(base::trace_event::TracedValue* value) const {
  if (this->assistant_tree.is_null()) {
    value->SetString("assistant_tree", "nullptr");
  } else {
    value->BeginDictionary("assistant_tree");
    this->assistant_tree->AsValueInto(value);
    value->EndDictionary();
  }
  if (this->assistant_extra.is_null()) {
    value->SetString("assistant_extra", "nullptr");
  } else {
    value->BeginDictionary("assistant_extra");
    this->assistant_extra->AsValueInto(value);
    value->EndDictionary();
  }
}

bool AssistantStructure::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace blink
}  // namespace mojom
}  // namespace ax

namespace mojo {


// static
bool StructTraits<::ax::mojom::blink::AssistantTree::DataView, ::ax::mojom::blink::AssistantTreePtr>::Read(
    ::ax::mojom::blink::AssistantTree::DataView input,
    ::ax::mojom::blink::AssistantTreePtr* output) {
  bool success = true;
  ::ax::mojom::blink::AssistantTreePtr result(::ax::mojom::blink::AssistantTree::New());
  
      if (success && !input.ReadNodes(&result->nodes))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::ax::mojom::blink::AssistantNode::DataView, ::ax::mojom::blink::AssistantNodePtr>::Read(
    ::ax::mojom::blink::AssistantNode::DataView input,
    ::ax::mojom::blink::AssistantNodePtr* output) {
  bool success = true;
  ::ax::mojom::blink::AssistantNodePtr result(::ax::mojom::blink::AssistantNode::New());
  
      if (success && !input.ReadChildrenIndices(&result->children_indices))
        success = false;
      if (success && !input.ReadRect(&result->rect))
        success = false;
      if (success && !input.ReadText(&result->text))
        success = false;
      if (success)
        result->text_size = input.text_size();
      if (success)
        result->color = input.color();
      if (success)
        result->bgcolor = input.bgcolor();
      if (success)
        result->bold = input.bold();
      if (success)
        result->italic = input.italic();
      if (success)
        result->underline = input.underline();
      if (success)
        result->line_through = input.line_through();
      if (success && !input.ReadSelection(&result->selection))
        success = false;
      if (success && !input.ReadClassName(&result->class_name))
        success = false;
      if (success && !input.ReadRole(&result->role))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::ax::mojom::blink::AssistantExtra::DataView, ::ax::mojom::blink::AssistantExtraPtr>::Read(
    ::ax::mojom::blink::AssistantExtra::DataView input,
    ::ax::mojom::blink::AssistantExtraPtr* output) {
  bool success = true;
  ::ax::mojom::blink::AssistantExtraPtr result(::ax::mojom::blink::AssistantExtra::New());
  
      if (success && !input.ReadUrl(&result->url))
        success = false;
      if (success && !input.ReadBoundsPixel(&result->bounds_pixel))
        success = false;
      if (success && !input.ReadTitle(&result->title))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::ax::mojom::blink::AssistantStructure::DataView, ::ax::mojom::blink::AssistantStructurePtr>::Read(
    ::ax::mojom::blink::AssistantStructure::DataView input,
    ::ax::mojom::blink::AssistantStructurePtr* output) {
  bool success = true;
  ::ax::mojom::blink::AssistantStructurePtr result(::ax::mojom::blink::AssistantStructure::New());
  
      if (success && !input.ReadAssistantTree(&result->assistant_tree))
        success = false;
      if (success && !input.ReadAssistantExtra(&result->assistant_extra))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif